#____________________________________________________________________________________
#
#    contentinfo (see README.txt for more information)
#    Copyright (C) 2002 Christoph Becker-Freyseng
#
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this library; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#
#    webmaster@beyond-thoughts.com
#    http://www.beyond-thoughts.com
#    http://www.mmc-startup.com
#____________________________________________________________________________________
#




__doc__="""this module analyses a file when it's a .gif"""
__version__='0.1.0'


import CIContentTypes
import CIExceptions

import struct


def analyseContent(datahead, fullsize):
    if len(datahead)<10:
        raise CIExceptions.DataheadError(tooSmall=1)
    if datahead[:6] == 'GIF87a': version = '87a'
    elif datahead[:6] == 'GIF89a': version = '89a'
    else:
	raise CIExceptions.UnknownContentError()
    if fullsize<10:
	raise CIExceptions.BrokenContentError()
    widthD, heightD= struct.unpack('<HH', datahead[6:10])
    return GifContent(fullsize, int(widthD), int(heightD), version)



class GifContent(CIContentTypes.FileContent, CIContentTypes.PictureContent, CIContentTypes.CodecContent):	# The class for the content of a gif-file
    def __init__(self, fullsize, width, height, codec):
	self.mimetype = 'image/gif'
        self.extension= '.gif'
        self.fullsize= fullsize
	self.width= width
	self.height= height
	self.codec= codec






def initAnalysers(registerFunc):
    registerFunc('image/gif', analyseContent)

