#____________________________________________________________________________________
#
#    contentinfo (see README.txt for more information)
#    Copyright (C) 2002 Christoph Becker-Freyseng
#
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this library; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#
#    webmaster@beyond-thoughts.com
#    http://www.beyond-thoughts.com
#    http://www.mmc-startup.com
#____________________________________________________________________________________
#




__doc__="""this module analyses a file when it's a .jpg
http://www.jpeg.org/
"""
__version__='0.1.0'


import CIContentTypes
import CIExceptions

import struct
from cStringIO import StringIO


def analyseContent(datahead, fullsize):
    if len(datahead)<=40:	#just guessed
        raise CIExceptions.DataheadError(tooSmall=1)
    dataStream= StringIO(datahead)
    if dataStream.read(2) != '\377\330':
	raise CIExceptions.UnknownContentError()
    try:
	width= None
	height= None
        byteD= dataStream.read(1)
        while (byteD and (ord(byteD) != 0xDA) and (width is None)):
            while (ord(byteD) != 0xFF):
		byteD= dataStream.read(1)
            while (ord(byteD) == 0xFF):
		byteD = dataStream.read(1)
            if ((ord(byteD) >= 0xC0) and (ord(byteD) <= 0xC3)):
                dataStream.read(3)
                height, width = struct.unpack('>HH', dataStream.read(4))
            else:
                dataStream.read(int(struct.unpack('>H', dataStream.read(2))[0])-2)
        	byteD= dataStream.read(1)
	if (width is not None) and (height is not None):
	    width = int(width)
	    height = int(height)
	else: # So it is broken
	    raise CIExceptions.BrokenContentError()
    except:	# So the datahead was too small
	raise CIExceptions.DataheadError(tooSmall=1)
    return JpegContent(fullsize, width, height)



class JpegContent(CIContentTypes.FileContent, CIContentTypes.PictureContent):
    def __init__(self, fullsize, width, height):
        self.mimetype = 'image/jpeg'
        self.extension= '.jpeg'
        self.fullsize= fullsize
        self.width= width
        self.height= height






def initAnalysers(registerFunc):
    registerFunc('image/jpeg', analyseContent)



